Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.security.cert
Class CertificateFactorySpi

    java.lang.Object
      |
      +--java.security.cert.CertificateFactorySpi

public abstract class CertificateFactorySpi
extends Object

This class defines the Service Provider Interface (SPI) for the `CertificateFactory` class. All the abstract methods in this class must be implemented by each cryptographic service provider who wishes to supply the implementation of a certificate factory for a particular certificate type, e.g., X.509.

Certificate factories are used to generate certificate and certificate revocation list (CRL) objects from their encoding.

A certificate factory for X.509 must return certificates that are an instance of `java.security.cert.X509Certificate`, and CRLs that are an instance of `java.security.cert.X509CRL`.

Since:
  1.2
See Also:
  `CertificateFactory`, `Certificate`, `X509Certificate`, `CRL`, `X509CRL`

Constructor Summary
`CertificateFactorySpi()`

Method Summary
`abstract Certificate` | `engineGenerateCertificate(InputStream inStream)` Generates a certificate object and initializes it with the data read from the input stream `inStream`.
`abstract Collection` | `engineGenerateCertificates(InputStream inStream)` Returns a (possibly empty) collection view of the certificates read from the given input stream `inStream`.
`abstract CRL` | `engineGenerateCRL(InputStream inStream)` Generates a certificate revocation list (CRL) object and initializes it with the data read from the input stream `inStream`.
`abstract Collection` | `engineGenerateCRLs(InputStream inStream)` Returns a (possibly empty) collection view of the CRLs read from the given input stream `inStream`.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CertificateFactorySpi

    public CertificateFactorySpi()

Method Detail

### engineGenerateCertificate

    public abstract Certificate engineGenerateCertificate(InputStream inStream)
                                                   throws CertificateException

  Generates a certificate object and initializes it with the data read from the input stream `inStream`.

  The given input stream `inStream` must contain a single certificate.

  In order to take advantage of the specialized certificate format supported by this certificate factory, the returned certificate object can be typecast to the corresponding certificate class. For example, if this certificate factory implements X.509 certificates, the returned certificate object can be typecast to the `X509Certificate` class.

  In the case of a certificate factory for X.509 certificates, the certificate provided in `inStream` must be DER-encoded and may be supplied in binary or printable (Base64) encoding. If the certificate is provided in Base64 encoding, it must be bounded at the beginning by -----BEGIN CERTIFICATE-----, and must be bounded at the end by -----END CERTIFICATE-----.

  Note that if the given input stream does not support `mark` and `reset`, this method will consume the entire input stream.

  Parameters:
    `inStream` - an input stream with the certificate data.
  Returns:
    a certificate object initialized with the data from the input stream.
  Throws:
    `CertificateException` - on parsing errors.

### engineGenerateCertificates

    public abstract Collection engineGenerateCertificates(InputStream inStream)
                                                   throws CertificateException

  Returns a (possibly empty) collection view of the certificates read from the given input stream `inStream`.

  In order to take advantage of the specialized certificate format supported by this certificate factory, each element in the returned collection view can be typecast to the corresponding certificate class. For example, if this certificate factory implements X.509 certificates, the elements in the returned collection can be typecast to the `X509Certificate` class.

  In the case of a certificate factory for X.509 certificates, `inStream` may contain a single DER-encoded certificate in the formats described for `generateCertificate`. In addition, `inStream` may contain a PKCS#7 certificate chain. This is a PKCS#7 SignedData object, with the only significant field being certificates. In particular, the signature and the contents are ignored. This format allows multiple certificates to be downloaded at once. If no certificates are present, an empty collection is returned.

  Note that if the given input stream does not support `mark` and `reset`, this method will consume the entire input stream.

  Parameters:
    `inStream` - the input stream with the certificates.
  Returns:
    a (possibly empty) collection view of java.security.cert.Certificate objects initialized with the data from the input stream.
  Throws:
    `CertificateException` - on parsing errors.

### engineGenerateCRL

    public abstract CRL engineGenerateCRL(InputStream inStream)
                                   throws CRLException

  Generates a certificate revocation list (CRL) object and initializes it with the data read from the input stream `inStream`.

  In order to take advantage of the specialized CRL format supported by this certificate factory, the returned CRL object can be typecast to the corresponding CRL class. For example, if this certificate factory implements X.509 CRLs, the returned CRL object can be typecast to the `X509CRL` class.

  Note that if the given input stream does not support `mark` and `reset`, this method will consume the entire input stream.

  Parameters:
    `inStream` - an input stream with the CRL data.
  Returns:
    a CRL object initialized with the data from the input stream.
  Throws:
    `CRLException` - on parsing errors.

### engineGenerateCRLs

    public abstract Collection engineGenerateCRLs(InputStream inStream)
                                           throws CRLException

  Returns a (possibly empty) collection view of the CRLs read from the given input stream `inStream`.

  In order to take advantage of the specialized CRL format supported by this certificate factory, each element in the returned collection view can be typecast to the corresponding CRL class. For example, if this certificate factory implements X.509 CRLs, the elements in the returned collection can be typecast to the `X509CRL` class.

  In the case of a certificate factory for X.509 CRLs, `inStream` may contain a single DER-encoded CRL. In addition, `inStream` may contain a PKCS#7 CRL set. This is a PKCS#7 SignedData object, with the only significant field being crls. In particular, the signature and the contents are ignored. This format allows multiple CRLs to be downloaded at once. If no CRLs are present, an empty collection is returned.

  Note that if the given input stream does not support `mark` and `reset`, this method will consume the entire input stream.

  Parameters:
    `inStream` - the input stream with the CRLs.
  Returns:
    a (possibly empty) collection view of java.security.cert.CRL objects initialized with the data from the input stream.
  Throws:
    `CRLException` - on parsing errors.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.